
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>jQuery Validate验证框架详解 / iVAN</title>

    <meta name="description" content="jQuery Validate验证框架详解 版本信息: /*! * jQuery Validation Plugin v1.14.0 * * http://jqueryvalidation.org/ * * Copyright (c) 2015 Jörn Zaefferer * Released under the MIT license */   一.导入js库 &lt;script type=&quot;text/javascript&quot; src=&quot;validate/jquery-1.6.2.min.js&quot; ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">jQuery Validate验证框架详解</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>版本信息：
<pre><code>/*!
 * jQuery Validation Plugin v1.14.0
 *
 * http://jqueryvalidation.org/
 *
 * Copyright (c) 2015 Jörn Zaefferer
 * Released under the MIT license
 */</code></pre>
<p> </p>
<p><strong>一、导入js库</strong></p>
<pre><code>&lt;script type="text/javascript" src="validate/jquery-1.6.2.min.js"&gt;&lt;/script&gt;
&lt;script type="text/javascript" src="validate/jquery.validate.min.js"&gt;&lt;/script&gt;</code></pre>
<p><strong>二、默认校验规则</strong></p>
<pre><code>(1)、required:true               必输字段
(2)、remote:"remote-valid.jsp"   使用ajax方法调用remote-valid.jsp验证输入值
(3)、email:true                  必须输入正确格式的电子邮件
(4)、url:true                    必须输入正确格式的网址
(5)、date:true                   必须输入正确格式的日期，日期校验ie6出错，慎用
(6)、dateISO:true                必须输入正确格式的日期(ISO)，例如：2009-06-23，1998/01/22 只验证格式，不验证有效性
(7)、number:true                 必须输入合法的数字(负数，小数)
(8)、digits:true                 必须输入整数
(9)、creditcard:true             必须输入合法的信用卡号
(10)、equalTo:"#password"        输入值必须和#password相同
(11)、accept:                    输入拥有合法后缀名的字符串（上传文件的后缀）
(12)、maxlength:5                输入长度最多是5的字符串(汉字算一个字符)
(13)、minlength:10               输入长度最小是10的字符串(汉字算一个字符)
(14)、rangelength:[5,10]         输入长度必须介于 5 和 10 之间的字符串")(汉字算一个字符)
(15)、range:[5,10]               输入值必须介于 5 和 10 之间
(16)、max:5                      输入值不能大于5
(17)、min:10                     输入值不能小于10</code></pre>
<p><strong>三、默认的提示</strong></p>
<pre><code>messages: {
required: "This field is required.",
remote: "Please fix this field.",
email: "Please enter a valid email address.",
url: "Please enter a valid URL.",
date: "Please enter a valid date.",
dateISO: "Please enter a valid date (ISO).",
dateDE: "Bitte geben Sie ein g眉ltiges Datum ein.",
number: "Please enter a valid number.",
numberDE: "Bitte geben Sie eine Nummer ein.",
digits: "Please enter only digits",
creditcard: "Please enter a valid credit card number.",
equalTo: "Please enter the same value again.",
accept: "Please enter a value with a valid extension.",
maxlength: $.validator.format("Please enter no more than {0} characters."),
minlength: $.validator.format("Please enter at least {0} characters."),
rangelength: $.validator.format("Please enter a value between {0} and {1} characters long."),
range: $.validator.format("Please enter a value between {0} and {1}."),
max: $.validator.format("Please enter a value less than or equal to {0}."),
min: $.validator.format("Please enter a value greater than or equal to {0}.")
},</code></pre>
<p>如需要修改，可在js代码中加入：
<pre><code>$.extend($.validator.messages, {
    required: "必选字段",
    remote: "请修正该字段",
    email: "请输入正确格式的电子邮件",
    url: "请输入合法的网址",
    date: "请输入合法的日期",
    dateISO: "请输入合法的日期 (ISO).",
    number: "请输入合法的数字",
    digits: "只能输入整数",
    creditcard: "请输入合法的信用卡号",
    equalTo: "请再次输入相同的值",
    accept: "请输入拥有合法后缀名的字符串",
    maxlength: $.validator.format("请输入一个长度最多是 {0} 的字符串"),
    minlength: $.validator.format("请输入一个长度最少是 {0} 的字符串"),
    rangelength: $.validator.format("请输入一个长度介于 {0} 和 {1} 之间的字符串"),
    range: $.validator.format("请输入一个介于 {0} 和 {1} 之间的值"),
    max: $.validator.format("请输入一个最大为 {0} 的值"),
    min: $.validator.format("请输入一个最小为 {0} 的值")
});</code></pre>
<p>推荐做法，将此文件放入messages_cn.js中，在页面中引入
<pre><code>&lt;script type="text/javascript" src="validate/messages_cn.js"&gt;&lt;/script&gt;</code></pre>
<p><strong>四、使用方式</strong><br />
1、metadata用法，将校验规则写到控件中
<pre><code>&lt;!DOCTYPE HTML&gt;
&lt;html&gt;
    &lt;head&gt;
        &lt;title&gt;jQuery Validate验证框架详解-metadata用法&lt;/title&gt;

        &lt;meta http-equiv="pragma" content="no-cache"&gt;
        &lt;meta http-equiv="cache-control" content="no-cache"&gt;
        &lt;meta http-equiv="expires" content="0"&gt;
        &lt;meta http-equiv="keywords" content="keyword1,keyword2,keyword3"&gt;
        &lt;meta http-equiv="description" content="This is my page"&gt;
        &lt;script type="text/javascript" src="validate/jquery-1.6.2.min.js"&gt;&lt;/script&gt;
        &lt;script type="text/javascript" src="validate/jquery.validate.min.js"&gt;&lt;/script&gt;
        &lt;script type="text/javascript" src="validate/jquery.metadata.min.js"&gt;&lt;/script&gt;
        &lt;script type="text/javascript" src="validate/messages_zh.js"&gt;&lt;/script&gt;
        &lt;script type="text/javascript"&gt;
        $(function(){
            $("#myform").validate();
        });
        &lt;/script&gt;
    &lt;/head&gt;

    &lt;body&gt;
        &lt;form id="myform" method="post" action=""&gt;
            &lt;p&gt;
                &lt;label for="myname"&gt;用户名：&lt;/label&gt;
                &lt;!-- id和name最好同时写上 --&gt;
                &lt;input id="myname" name="myname" class="required" /&gt;
            &lt;/p&gt;
            &lt;p&gt;
                &lt;label for="email"&gt;E-Mail：&lt;/label&gt;
                &lt;input id="email" name="email" class="required email" /&gt;
            &lt;/p&gt;
            &lt;p&gt;
                &lt;label for="password"&gt;登陆密码：&lt;/label&gt;
                &lt;input id="password" name="password" type="password"
                    class="{required:true,minlength:5}" /&gt;
            &lt;/p&gt;
            &lt;p&gt;
                &lt;label for="confirm_password"&gt;确认密码：&lt;/label&gt;
                &lt;input id="confirm_password" name="confirm_password" type="password"
                    class="{required:true,minlength:5,equalTo:'#password'}" /&gt;
            &lt;/p&gt;
            &lt;p&gt;
                &lt;label for="confirm_password"&gt;性别：&lt;/label&gt;
                &lt;!-- 表示必须选中一个 --&gt;
                &lt;input  type="radio" id="gender_male" value="m" name="gender" class="{required:true}" /&gt;
                &lt;input  type="radio" id="gender_female" value="f" name="gender"/&gt;
            &lt;/p&gt;
            &lt;p&gt;
                &lt;label for="confirm_password"&gt;爱好：&lt;/label&gt;
                &lt;!-- checkbox的minlength表示必须选中的最小个数,maxlength表示最大的选中个数,rangelength:[2,3]表示选中个数区间  --&gt;
                &lt;input type="checkbox" id="spam_email" value="email" name="spam[]" class="{required:true, minlength:2}" /&gt;
                &lt;input type="checkbox" id="spam_phone" value="phone" name="spam[]" /&gt;
                &lt;input type="checkbox" id="spam_mail" value="mail" name="spam[]" /&gt;
            &lt;/p&gt;
            &lt;p&gt;
                &lt;label for="confirm_password"&gt;城市：&lt;/label&gt;
                &lt;select id="jungle" name="jungle" title="Please select something!" class="{required:true}"&gt;
                    &lt;option value=""&gt;&lt;/option&gt;
                    &lt;option value="1"&gt;厦门&lt;/option&gt;
                    &lt;option value="2"&gt;泉州&lt;/option&gt;
                &lt;option value="3"&gt;Oi&lt;/option&gt;
            &lt;/select&gt;
            &lt;/p&gt;
            &lt;p&gt;
                &lt;input class="submit" type="submit" value="立即注册" /&gt;
            &lt;/p&gt;
        &lt;/form&gt;
    &lt;/body&gt;
&lt;/html&gt;</code></pre>
<p> </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzI3MDMyNC8yMDEzMTEvMTkxNzE5MzUtMTY1NzcwN2Q2OWYzNDZjMWI4MjkzNGNjZDdiN2IzNGYucG5n.jpg"></p>
<p>使用class="{}"的方式，必须引入插件包：<strong>jquery.metadata.js</strong>；</p>
<p>可以使用如下的方法，修改提示内容：class="{required:true,minlength:5,messages:{required:'请输入内容'}}"；<br />
在使用equalTo关键字时，后面的内容必须加上引号，如下代码：class="{required:true,minlength:5,equalTo:'#password'}"。</p>
<p>2、将校验规则写到js代码中</p>
<pre><code>&lt;!DOCTYPE HTML&gt;
&lt;html&gt;
    &lt;head&gt;
        &lt;title&gt;jQuery Validate验证框架详解&lt;/title&gt;

        &lt;meta http-equiv="pragma" content="no-cache"&gt;
        &lt;meta http-equiv="cache-control" content="no-cache"&gt;
        &lt;meta http-equiv="expires" content="0"&gt;
        &lt;meta http-equiv="keywords" content="keyword1,keyword2,keyword3"&gt;
        &lt;meta http-equiv="description" content="This is my page"&gt;
        &lt;script type="text/javascript" src="&lt;%=request.getContextPath()%&gt;/validate/jquery-1.6.2.min.js"&gt;&lt;/script&gt;
        &lt;script type="text/javascript" src="&lt;%=request.getContextPath()%&gt;/validate/jquery.validate.min.js"&gt;&lt;/script&gt;
        &lt;script type="text/javascript"&gt;
        $(function(){
            var validate = $("#myform").validate({
                debug: true, //调试模式取消submit的默认提交功能
                //errorClass: "label.error", //默认为错误的样式类为：error
                focusInvalid: false, //当为false时，验证无效时，没有焦点响应
                onkeyup: false,
                submitHandler: function(form){   //表单提交句柄,为一回调函数，带一个参数：form
                    alert("提交表单");
                    form.submit();   //提交表单
                },   

                rules:{
                    myname:{
                        required:true
                    },
                    email:{
                        required:true,
                        email:true
                    },
                    password:{
                        required:true,
                        rangelength:[3,10]
                    },
                    confirm_password:{
                        equalTo:"#password"
                    }
                },
                messages:{
                    myname:{
                        required:"必填"
                    },
                    email:{
                        required:"必填",
                        email:"E-Mail格式不正确"
                    },
                    password:{
                        required: "不能为空",
                        rangelength: $.validator.format("密码最小长度:{0}, 最大长度:{1}。")
                    },
                    confirm_password:{
                        equalTo:"两次密码输入不一致"
                    }
                }

            });    

        });
        &lt;/script&gt;
    &lt;/head&gt;

    &lt;body&gt;
        &lt;form id="myform" method="post" action=""&gt;
            &lt;p&gt;
                &lt;label for="myname"&gt;用户名：&lt;/label&gt;
                &lt;!-- id和name最好同时写上 --&gt;
                &lt;input id="myname" name="myname" /&gt;
            &lt;/p&gt;
            &lt;p&gt;
                &lt;label for="email"&gt;E-Mail：&lt;/label&gt;
                &lt;input id="email" name="email" /&gt;
            &lt;/p&gt;
            &lt;p&gt;
                &lt;label for="password"&gt;登陆密码：&lt;/label&gt;
                &lt;input id="password" name="password" type="password" /&gt;
            &lt;/p&gt;
            &lt;p&gt;
                &lt;label for="confirm_password"&gt;确认密码：&lt;/label&gt;
                &lt;input id="confirm_password" name="confirm_password" type="password" /&gt;
            &lt;/p&gt;
            &lt;p&gt;
                &lt;input class="submit" type="submit" value="立即注册" /&gt;
            &lt;/p&gt;
        &lt;/form&gt;
    &lt;/body&gt;
&lt;/html&gt;</code></pre>
<p> </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzI3MDMyNC8yMDEzMTEvMTkxNzIwMTQtYmU3OTdmNmE0NDQ4NGUyNWFjOTdlYTEzMDczZGExNDgucG5n.jpg"></p>
<p><strong>五、常用方法及注意问题</strong><br />
1、用其他方式替代默认的submit</p>
<pre><code>$(function(){
   $("#signupForm").validate({
        submitHandler:function(form){
            alert("submit!");
            form.submit();
        }
    });
});</code></pre>
<p>可以设置validate的默认值，写法如下：
<pre><code>

$.validator.setDefaults({
    submitHandler: function(form) { alert("submit!"); form.submit(); }
});
</code></pre>
<p> </p>
<p>如果想提交表单，需要使用form.submit()，而不要使用$(form).submit()。</p>
<p> </p>
<p>2、debug，只验证不提交表单<br />
如果这个参数为true，那么表单不会提交，只进行检查，调试时十分方便</p>
<pre><code>$(function(){
    $("#signupForm").validate({
        debug:true
    });
});</code></pre>
<p>如果一个页面中有多个表单都想设置成为debug，用</p>
<pre><code>

$.validator.setDefaults({
    debug: true
})
</code></pre>
<p> </p>
<p>3、ignore：忽略某些元素不验证</p>
<pre><code>ignore: ".ignore"</code></pre>
<p> </p>
<p>4、更改错误信息显示的位置</p>
<p>指明错误放置的位置。</p>
<p>默认情况是：</p>
<pre><code>errorPlacement: function(error, element) {
     error.appendTo(element.parent());
}</code></pre>
<p>即把错误信息放在验证的元素后面。</p>
<p>示例：</p>
<pre><code>&lt;tr&gt;
    &lt;td class="label"&gt;&lt;label id="lfirstname" for="firstname"&gt;First Name&lt;/label&gt;&lt;/td&gt;
    &lt;td class="field"&gt;&lt;input id="firstname" name="firstname" type="text" value="" maxlength="100" /&gt;&lt;/td&gt;
    &lt;td class="status"&gt;&lt;/td&gt;
&lt;/tr&gt;
&lt;tr&gt;
    &lt;td style="padding-right: 5px;"&gt;
        &lt;input id="dateformat_eu" name="dateformat" type="radio" value="0" /&gt;
        &lt;label id="ldateformat_eu" for="dateformat_eu"&gt;14/02/07&lt;/label&gt;
    &lt;/td&gt;
    &lt;td style="padding-left: 5px;"&gt;
        &lt;input id="dateformat_am" name="dateformat" type="radio" value="1"  /&gt;
        &lt;label id="ldateformat_am" for="dateformat_am"&gt;02/14/07&lt;/label&gt;
    &lt;/td&gt;
    &lt;td&gt;&lt;/td&gt;
&lt;/tr&gt;
&lt;tr&gt;
    &lt;td class="label"&gt; &lt;/td&gt;
    &lt;td class="field" colspan="2"&gt;
        &lt;div id="termswrap"&gt;
            &lt;input id="terms" type="checkbox" name="terms" /&gt;
            &lt;label id="lterms" for="terms"&gt;I have read and accept the Terms of Use.&lt;/label&gt;
        &lt;/div&gt;
    &lt;/td&gt;
&lt;/tr&gt;

errorPlacement: function(error, element) {
    if (element.is(":radio"))
        error.appendTo(element.parent().next().next());
    else if (element.is(":checkbox"))
        error.appendTo(element.next());
    else
        error.appendTo(element.parent().next());
}</code></pre>
<p>代码的作用是：一般情况下把错误信息显示在 &lt;td class="status"&gt;&lt;/td&gt; 中，如果是 radio 则显示在 &lt;td&gt;&lt;/td&gt; 中，如果是 checkbox 则显示在内容的后面。</p>
<table>
<tbody>
<tr>
<th>参数</th>
<th>类型</th>
<th>描述</th>
<th>默认值</th>
</tr>
<tr>
<td>errorClass</td>
<td>String</td>
<td>指定错误提示的 css 类名，可以自定义错误提示的样式。</td>
<td>"error"</td>
</tr>
<tr>
<td>errorElement</td>
<td>String</td>
<td>用什么标签标记错误，默认是 label，可以改成 em。</td>
<td>"label"</td>
</tr>
<tr>
<td>errorContainer</td>
<td>Selector</td>
<td>显示或者隐藏验证信息，可以自动实现有错误信息出现时把容器属性变为显示，无错误时隐藏，用处不大。<br />
errorContainer: "#messageBox1, #messageBox2"</td>
<td> </td>
</tr>
<tr>
<td>errorLabelContainer</td>
<td>Selector</td>
<td>把错误信息统一放在一个容器里面。</td>
<td> </td>
</tr>
<tr>
<td>wrapper</td>
<td>String</td>
<td>用什么标签再把上边的 errorELement 包起来。</td>
<td> </td>
</tr>
</tbody>
</table>
<p>一般这三个属性同时使用，实现在一个容器内显示所有错误提示的功能，并且没有信息时自动隐藏。</p>
<pre><code>errorContainer: "div.error",
errorLabelContainer: $("#signupForm div.error"),
wrapper: "li"</code></pre>
<p> </p>
<p>5、更改错误信息显示的样式<br />
设置错误提示的样式，可以增加图标显示，在该系统中已经建立了一个validation.css专门用于维护校验文件的样式</p>
<pre><code>input.error { border: 1px solid red; }
label.error {
    background:url("./demo/images/unchecked.gif") no-repeat 0px 0px;
    padding-left: 16px;
    padding-bottom: 2px;
    font-weight: bold;
    color: #EA5200;
}
label.checked {
    background:url("./demo/images/checked.gif") no-repeat 0px 0px;
}</code></pre>
<p> </p>
<p>6、每个字段验证通过执行函数<br />
success：String,Callback</p>
<p>要验证的元素通过验证后的动作，如果跟一个字符串，会当做一个css类，也可跟一个函数</p>
<pre><code>success: function(label) {
    // set   as text for IE
    label.html(" ").addClass("checked");
    //label.addClass("valid").text("Ok!")
}</code></pre>
<p> </p>
<p>添加"valid"到验证元素, 在CSS中定义的样式&lt;style&gt;label.valid {}&lt;/style&gt;<br />
success: "valid"</p>
<p> </p>
<p>7、验证的触发方式修改<br />
下面的虽然是boolean型的，但建议除非要改为false,否则别乱添加。</p>
<p>1) onsubmit：Boolean Default: true <br />
提交时验证. 设置唯false就用其他方法去验证</p>
<p>2) onfocusout：Boolean Default: true <br />
失去焦点是验证(不包括checkboxes/radio buttons)<br />
c.onkeyup：Boolean Default: true <br />
在keyup时验证.</p>
<p>3) onclick：Boolean Default: true <br />
在checkboxes 和 radio 点击时验证</p>
<p>4) focusInvalid：Boolean Default: true <br />
提交表单后，未通过验证的表单(第一个或提交之前获得焦点的未通过验证的表单)会获得焦点。</p>
<p>5) focusCleanup：Boolean Default: false <br />
如果是true那么当未通过验证的元素获得焦点时，移除错误提示。避免和focusInvalid一起用</p>
<p>8、异步验证<br />
格式：remote：URL</p>
<p>使用ajax方式进行验证，默认会提交当前验证的值到远程地址，如果需要提交其他的值，可以使用data选项</p>
<pre><code>示例一：
remote: "check-email.php"
示例二：
remote: {
    url: "check-email.php",     //后台处理程序
    type: "post",               //数据发送方式
    dataType: "json",           //接受数据格式
    data: {                     //要传递的数据
        username: function() {
            return $("#username").val();
        }
    }
}</code></pre>
<p> </p>
<p>远程地址只能输出"true"或"false"，不能有其它输出。</p>
<p>9、添加自定义校验<br />
格式：addMethod：name, method, message</p>
<p>自定义验证方法：</p>
<pre><code>// 中文字两个字节
jQuery.validator.addMethod(
    "byteRangeLength",
    function(value, element, param) {
        var length = value.length;
        for(var i = 0; i &lt; value.length; i++){
            if(value.charCodeAt(i) &gt; 127){
                length++;
            }
        }
        return this.optional(element) || (length &gt;= param[0] &amp;&amp; length &lt;= param[1]);
    },
    $.validator.format("请确保输入的值在{0}-{1}个字节之间(一个中文字算2个字节)")
);

// 邮政编码验证
jQuery.validator.addMethod("isZipCode", function(value, element) {
    var tel = /^[0-9]{6}$/;
    return this.optional(element) || (tel.test(value));
}, "请正确填写您的邮政编码");</code></pre>
<p> </p>
<p>1) 要在additional-methods.js文件中添加或者在jquery.validate.js添加<br />
建议一般写在additional-methods.js文件中</p>
<p>2) 在messages_cn.js文件添加：isZipCode: "只能包括中文字、英文字母、数字和下划线",<br />
调用前要添加对additional-methods.js文件的引用。</p>
<p> </p>
<p>10、radio和checkbox、select的验证</p>
<p> </p>
<pre><code>1.radio的required表示必须选中一个
&lt;input  type="radio" id="gender_male" value="m" name="gender" class="{required:true}" /&gt;
&lt;input  type="radio" id="gender_female" value="f" name="gender"/&gt;

2.checkbox的required表示必须选中
&lt;input type="checkbox" class="checkbox" id="agree" name="agree" class="{required:true}" /&gt;

checkbox的minlength表示必须选中的最小个数,maxlength表示最大的选中个数,rangelength:[2,3]表示选中个数区间
&lt;input type="checkbox" id="spam_email" value="email" name="spam[]" class="{required:true, minlength:2}" /&gt;
&lt;input type="checkbox" id="spam_phone" value="phone" name="spam[]" /&gt;
&lt;input type="checkbox" id="spam_mail" value="mail" name="spam[]" /&gt;

3.select的required表示选中的value不能为空
&lt;select id="jungle" name="jungle" title="Please select something!" class="{required:true}"&gt;
    &lt;option value=""&gt;&lt;/option&gt;
    &lt;option value="1"&gt;Buga&lt;/option&gt;
    &lt;option value="2"&gt;Baga&lt;/option&gt;
    &lt;option value="3"&gt;Oi&lt;/option&gt;
&lt;/select&gt;

select的minlength表示选中的最小个数（可多选的select）,maxlength表示最大的选中个 数,rangelength:[2,3]表示选中个数区间
&lt;select id="fruit" name="fruit" title="Please select at least two fruits" class="{required:true, minlength:2}" multiple="multiple"&gt;
    &lt;option value="b"&gt;Banana&lt;/option&gt;
    &lt;option value="a"&gt;Apple&lt;/option&gt;
    &lt;option value="p"&gt;Peach&lt;/option&gt;
    &lt;option value="t"&gt;Turtle&lt;/option&gt;
&lt;/select&gt;</code></pre>
<p> </p>
<p> </p>
<p>更完整的示例：</p>
<pre><code>&lt;!DOCTYPE html&gt;
&lt;head&gt;
    &lt;meta charset="utf-8"&gt;
    &lt;title&gt;title&lt;/title&gt;
    &lt;script src="../lib/jquery.js" type="text/javascript"&gt;&lt;/script&gt;
    &lt;script src="../dist/jquery.validate.js" type="text/javascript"&gt;&lt;/script&gt;
    &lt;script src="../lib/jquery.metadata.js" type="text/javascript"&gt;&lt;/script&gt;
    &lt;style&gt;
        label.error{
            color:red;
        }
        label.valid{
            color:green;
        }

    &lt;/style&gt;
&lt;/head&gt;

&lt;body&gt;

    &lt;form id="myform" method="get" action=""&gt;
        &lt;p&gt;
            &lt;label for="firstname"&gt;Firstname&lt;/label&gt;
            &lt;input id="firstname" name="firstname" class="required" /&gt;
        &lt;/p&gt;
     &lt;p&gt;
      &lt;label for="email"&gt;E-Mail&lt;/label&gt;
      &lt;input id="email" name="email" class="required email" /&gt;
     &lt;/p&gt;
     &lt;p&gt;
      &lt;label for="password"&gt;Password&lt;/label&gt;
      &lt;input id="password" name="password" type="password" class="{required:true,minlength:5}" /&gt;
     &lt;/p&gt;
     &lt;p&gt;
      &lt;label for="confirm_password"&gt;确认密码&lt;/label&gt;
      &lt;input id="confirm_password" name="confirm_password" type="password" class="{required:true,minlength:5,equalTo:'#password'}" /&gt;
     &lt;/p&gt;

     &lt;p&gt;
      &lt;label for="ZipCode"&gt;邮政编码&lt;/label&gt;
      &lt;input  name="ZipCode" type="text" /&gt;
     &lt;/p&gt;

     &lt;p&gt;
      &lt;label for="Chinese"&gt;中文姓名&lt;/label&gt;
      &lt;input  name="Chinese" type="text" /&gt;
     &lt;/p&gt;

     &lt;p&gt;
      &lt;label for="user"&gt;用户名&lt;/label&gt;
      &lt;input  name="user" type="text" /&gt;
     &lt;/p&gt;

     &lt;p&gt;
      &lt;label for="myregex"&gt;自定义正则&lt;/label&gt;
      &lt;input  name="myregex" type="text" /&gt;
     &lt;/p&gt;

     &lt;!-- radio的required表示必须选中一个 --&gt;
      &lt;p&gt;
        &lt;input  type="radio" id="gender_male" value="m" name="gender" class="{required:true}" /&gt;男
        &lt;input  type="radio" id="gender_female" value="f" name="gender"/&gt;女
     &lt;/p&gt;

     &lt;!-- checkbox的required表示必须选中 --&gt;
      &lt;p&gt;
        &lt;input type="checkbox" class="checkbox" id="agree" name="agree" class="{required:true}" /&gt;同意协议
     &lt;/p&gt;

     &lt;!-- checkbox的minlength表示必须选中的最小个数,maxlength表示最大的选中个数,rangelength:[2,3]表示选中个数区间 --&gt;
      &lt;p&gt;
        &lt;input type="checkbox" id="spam_email" value="email" name="spam[]" class="{required:true, minlength:2}" /&gt;邮箱
        &lt;input type="checkbox" id="spam_phone" value="phone" name="spam[]" /&gt;电话
        &lt;input type="checkbox" id="spam_mail" value="mail" name="spam[]" /&gt;邮件
     &lt;/p&gt;

     &lt;!-- select的required表示选中的value不能为空 --&gt;
      &lt;p&gt;
        &lt;select id="jungle" name="jungle" title="请选择选项!" class="{required:true}"&gt;
            &lt;option value=""&gt;请选择&lt;/option&gt;
            &lt;option value="1"&gt;Buga&lt;/option&gt;
            &lt;option value="2"&gt;Baga&lt;/option&gt;
            &lt;option value="3"&gt;Oi&lt;/option&gt;
        &lt;/select&gt;
     &lt;/p&gt;

     &lt;!-- select的minlength表示选中的最小个数（可多选的select）,maxlength表示最大的选中个 数,rangelength:[2,3]表示选中个数区间 --&gt;
      &lt;p&gt;
        &lt;select id="fruit" name="fruit" title="请至少选择2种水果！" class="{required:true, minlength:2}" multiple="multiple"&gt;
            &lt;option value="b"&gt;Banana&lt;/option&gt;
            &lt;option value="a"&gt;Apple&lt;/option&gt;
            &lt;option value="p"&gt;Peach&lt;/option&gt;
            &lt;option value="t"&gt;Turtle&lt;/option&gt;
        &lt;/select&gt;
     &lt;/p&gt;

        &lt;p&gt;
            &lt;input class="submit" type="submit" value="Submit"/&gt;
        &lt;/p&gt;
    &lt;/form&gt;

    &lt;script&gt;
        //$().ready(function() {
        //    $("#myform").validate();
        //});

        $(function(){
            var validate = $("#myform").validate({
                debug: true, //调试模式取消submit的默认提交功能
                //errorClass: "label.error", //默认为错误的样式类为：error
                focusInvalid: false, //当为false时，验证无效时，没有焦点响应
                onkeyup: false,
                submitHandler: function(form){   //表单提交句柄,为一回调函数，带一个参数：form
                    alert("提交表单");
                    form.submit();   //提交表单
                },   

                rules:{
                    firstname:{
                        required:true
                    },
                    email:{
                        required:true,
                        email:true
                    },
                    email2:{
                        remote: "check-email.php",

                        /*使用ajax方式进行验证，默认会提交当前验证的值到远程地址。
                        如果需要提交其他的值，可以使用data选项。
                        远程地址只能输出"true"或"false"，不能有其它输出。*/
                        remote: {
                            url: "check-email.php",     //后台处理程序
                            type: "post",               //数据发送方式
                            dataType: "json",           //接受数据格式
                            data: {                     //要传递的数据
                                username: function() {
                                    return $("#username").val();
                                }
                            }
                        }
                    },
                    user:{
                        required:true,
                        remote: "remote.php",
                    },
                    password:{
                        required:true,
                        rangelength:[5,10]
                    },
                    confirm_password:{
                        required:true,
                        rangelength:[5,10],
                        equalTo:"#password"
                    },
                    gender:{
                        required:true
                    },
                    agree:{
                        required:true
                    },
                    'spam[]':{
                        required:true,
                        minlength:2
                    },
                    jungle:{
                        required:true
                    },
                    fruit:{
                        required:true
                    },
                    ZipCode:{
                        required:true,
                        isZipCode:true
                    },
                    Chinese:{
                        required:true,
                        isChar:true
                    },
                    myregex:{
                        regex:/^1([3578]\d|4[57])\d{8}$/
                    }
                },
                messages:{
                    firstname:{
                        required:"姓名必填"
                    },
                    email:{
                        required:"邮箱必填",
                        email:"E-Mail格式不正确"
                    },
                    password:{
                        required: "密码不能为空",
                        rangelength: $.validator.format("密码最小长度:{0}, 最大长度:{1}。")
                    },
                    confirm_password:{
                        required:"确认密码必填",
                        rangelength:$.validator.format("密码最小长度:{0}, 最大长度:{1}。"),
                        equalTo:"两次密码输入不一致"
                    },
                    myregex:{
                        regex:"手机号码非法"
                    },
                    user:{
                        required:"用户名必填",
                        remote: "用户名已经存在！",
                    },
                },

                /*可选：更改错误信息显示的位置*/
                errorPlacement: function(error, element) {
                    //alert(error[0].innerText);
                    error.appendTo(element.parent());
                },

                /*可选：每个字段验证通过执行函数*/
                success: function(label) {
                    // set   as text for IE
                    label.html(" ").addClass("checked");
                    label.addClass("valid").text("Ok!")
                }

            });    

        });

        /*默认的提示*/
        $.extend($.validator.messages, {
            required: "必选字段",
            remote: "请修正该字段",
            email: "请输入正确格式的电子邮件",
            url: "请输入合法的网址",
            date: "请输入合法的日期",
            dateISO: "请输入合法的日期 (ISO).",
            number: "请输入合法的数字",
            digits: "只能输入整数",
            creditcard: "请输入合法的信用卡号",
            equalTo: "请再次输入相同的值",
            accept: "请输入拥有合法后缀名的字符串",
            maxlength: $.validator.format("请输入一个长度最多是 {0} 的字符串"),
            minlength: $.validator.format("请输入一个长度最少是 {0} 的字符串"),
            rangelength: $.validator.format("请输入一个长度介于 {0} 和 {1} 之间的字符串"),
            range: $.validator.format("请输入一个介于 {0} 和 {1} 之间的值"),
            max: $.validator.format("请输入一个最大为 {0} 的值"),
            min: $.validator.format("请输入一个最小为 {0} 的值")
        });

        /**添加自定义校验
            addMethod：name, method, message
        */

        // 中文字两个字节
        jQuery.validator.addMethod(
            "byteRangeLength",
            function(value, element, param) {
                var length = value.length;
                for(var i = 0; i &lt; value.length; i++){
                    if(value.charCodeAt(i) &gt; 127){
                        length++;
                    }
                }
                return this.optional(element) || (length &gt;= param[0] &amp;&amp; length &lt;= param[1]);
            },
            $.validator.format("请确保输入的值在{0}-{1}个字节之间(一个中文字算2个字节)")
        );

        // 邮政编码验证
        jQuery.validator.addMethod("isZipCode", function(value, element) {
            var tel = /^[0-9]{6}$/;
            return this.optional(element) || (tel.test(value));
        }, "请正确填写您的邮政编码");

        //检测用户姓名是否为汉字
        jQuery.validator.addMethod('isChar', function(value, element) {
            var length = value.length;
            var regName = /[^\u4e00-\u9fa5]/g;
            return this.optional(element) || !regName.test( value );
        }, "请正确格式的姓名(暂支持汉字)"); 

        // 自定义方法支持正则 ，例如手机号验证/^1([3578]\d|4[57])\d{8}$/
        jQuery.validator.addMethod("regex", function(value, element, param) {
            var r = param;
            return r.test(value);
        }, "填写不正确");

    &lt;/script&gt;
&lt;/body&gt;</code></pre>
<p>remote.php
<pre><code>&lt;?php

echo json_encode(false);exit;</code></pre>
<p> </p>
<h2>jQuery.validate 中文 API</h2>
<table>
<tbody>
<tr>
<th>名称</th>
<th>返回类型</th>
<th>描述</th>
</tr>
<tr>
<td>validate(options)</td>
<td>Validator</td>
<td>验证所选的 FORM。</td>
</tr>
<tr>
<td>valid()</td>
<td>Boolean</td>
<td>检查是否验证通过。</td>
</tr>
<tr>
<td>rules()</td>
<td>Options</td>
<td>返回元素的验证规则。</td>
</tr>
<tr>
<td>rules("add",rules)</td>
<td>Options</td>
<td>增加验证规则。</td>
</tr>
<tr>
<td>rules("remove",rules)</td>
<td>Options</td>
<td>删除验证规则。</td>
</tr>
<tr>
<td>removeAttrs(attributes)</td>
<td>Options</td>
<td>删除特殊属性并且返回它们。</td>
</tr>
<tr>
<td colspan="3">自定义选择器</td>
</tr>
<tr>
<td>:blank</td>
<td>Validator</td>
<td>没有值的筛选器。</td>
</tr>
<tr>
<td>:filled</td>
<td>Array &lt;Element&gt;</td>
<td>有值的筛选器。</td>
</tr>
<tr>
<td>:unchecked</td>
<td>Array &lt;Element&gt;</td>
<td>没选择的元素的筛选器。</td>
</tr>
<tr>
<td colspan="3">实用工具</td>
</tr>
<tr>
<td>jQuery.format(template,argument,argumentN...)</td>
<td>String</td>
<td>用参数代替模板中的 {n}。</td>
</tr>
</tbody>
</table>
<h3>Validator</h3>
<p>validate 方法返回一个 Validator 对象。Validator 对象有很多方法可以用来引发校验程序或者改变 form 的内容，下面列出几个常用的方法。</p>
<table>
<tbody>
<tr>
<th>名称</th>
<th>返回类型</th>
<th>描述</th>
</tr>
<tr>
<td>form()</td>
<td>Boolean</td>
<td>验证 form 返回成功还是失败。</td>
</tr>
<tr>
<td>element(element)</td>
<td>Boolean</td>
<td>验证单个元素是成功还是失败。</td>
</tr>
<tr>
<td>resetForm()</td>
<td>undefined</td>
<td>把前面验证的 FORM 恢复到验证前原来的状态。</td>
</tr>
<tr>
<td>showErrors(errors)</td>
<td>undefined</td>
<td>显示特定的错误信息。</td>
</tr>
<tr>
<td colspan="3">Validator 函数</td>
</tr>
<tr>
<td>setDefaults(defaults)</td>
<td>undefined</td>
<td>改变默认的设置。</td>
</tr>
<tr>
<td>addMethod(name,method,message)</td>
<td>undefined</td>
<td>添加一个新的验证方法。必须包括一个独一无二的名字，一个 JAVASCRIPT 的方法和一个默认的信息。</td>
</tr>
<tr>
<td>addClassRules(name,rules)</td>
<td>undefined</td>
<td>增加组合验证类型，在一个类里面用多种验证方法时比较有用。</td>
</tr>
<tr>
<td>addClassRules(rules)</td>
<td>undefined</td>
<td>增加组合验证类型，在一个类里面用多种验证方法时比较有用。这个是同时加多个验证方法。</td>
</tr>
</tbody>
</table>
<h3> </h3>
<p> </p>
<p>附录：</p>
<p> 让jquery validation plugin 支持zepto</p>
<p>http://blog.csdn.net/weizengxun/article/details/44604995#javascript</p>
<p> </p>
<p>需要引入zepto的ajax，data，event，form，selector插件。</p>
<p>另外代码里：</p>
<pre><code>

var args = [].slice.call(arguments[0])//$.makeArray(arguments);
</code></pre>
<p>替换为：
<pre><code>

var args = [].slice.call(arguments[0])//$.makeArray(arguments);
</code></pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 08:15:59</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/jquery/" title="jquery">jquery</a>, <a href="https://www.iamivan.net/tag/javascript/" title="javascript">javascript</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>jQuery Validate验证框架详解的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrdoLxz.html" rel="bookmark">jQuery Validate验证框架详解&lpar;推荐&rpar;&lowbar;jquery</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				jQuery Validate 插件为表单提供了强大的验证功能,让客户端表单验证变得更简单,同时提供了大量的定制选项,满足应用程序各种需求. 一.导入js库 &lt;script type=&quot;text/javascript&quot; src=&quot;&lt;%=path %&gt;/validate/jquery-1.6.2.min.js&quot;&gt;&lt;/script&gt; &lt;script type=&quot;text/javascript&quot; src=&qu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MN0ZYWz.html" rel="bookmark">jQuery Validate验证框架经典大全&lowbar;jquery</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				jQuery校验官网地址:http://bassistance.de/jquery-plugins/jquery-plugin-validation 一.导入js库 &lt;script type=&quot;text/javascript&quot; src=&quot;&lt;%=path %&gt;/validate/jquery-1.6.2.min.js&quot;&gt;&lt;/script&gt; &lt;script type=&quot;text/javascript&quot; src			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0PgVnM.html" rel="bookmark">在Struts中使用Validator验证框架详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Validatro框架以成为Jakarta的公共项目的一部分,可以从http://jakarta.apache.org/commons/下载单独的Validator框架,在Struts中已经呆了这个框架. Validator主要依赖两个jar包 Jakarta-oro.jar:-提供一组处理文本的类,具有文本替换.过滤.和分割功能. Commons-validator.jar:提供了一个简单.可扩展的验证框架,包含了通用的验证方法和验证规则. 在用Struts中用这个框架,需加入这两个包,用起来			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQ1YDrb.html" rel="bookmark">jQuery验证插件validate使用方法详解&lowbar;jquery</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 写在前面 我们知道,用户在注册的时候,会有个表单页面,然后有些选项是必填的,有些要填的内容是有规范的,这些都要在用户提交之前进行验证才行,如果不符合要求,需要在右边显示一个友好的提示,让用户修改. 记得以前在学习Servlet的时候,实现一个简单的用户注册功能的验证是在后台做的,有些用了正则表达式,有些没用,但是都比较简单.流程是这样的,前台提交表单数据后,servlet获取数据先进行验证,如果不符合要求,将提示信息放到一个List中,然后再把List存到session中,跳转到一个新的页			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPlawZp.html" rel="bookmark">jQuery validate验证插件使用详解&lowbar;jquery</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Validate验证插件,内置丰富的验证规则,还有灵活的自定义规则接口,HTML.CSS与JS之间的低耦合能让您自由布局和丰富样式,支持input,select,textarea的验证. Description 浏览器支持:IE7+ .Chrome.Firefox.Safari.Mobile Browser jQuery版本:1.7.0+ Usage 载入jQuery.validate &lt;script type=&quot;text/javascript&quot; src=&quot;jquery			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0Bgwnz.html" rel="bookmark">Struts2数据输入验证教程详解&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.前言 1.1.什么是输入验证?为什么需要输入验证? 在上一篇文章中,我们学习了数据类型转换,我们提到了表示层数据处理的两个方法,也提到了用户输入数据需要进行类型转换才能得到我们想要的数据,那么,我们怎么确定类型转换后的数据,是我们想要的数据呢?这里有点绕.你可以这样想:一个成年男子年龄是18岁,你现在想要得到18这个数据,但是,用户输入32,经过类型转换也是对的,但是数据不是你想要的.这时候,我们要怎么办?所以输入验证在这里就有用处了. 类型转换和输入验证的关系是:类型转换是输入验证的前提,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bojZqXz.html" rel="bookmark">jQuery Event&period;which 属性详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				jQuery Event.which 属性详解   which属性用于返回触发当前事件时按下的键盘按键或鼠标按钮. 对于键盘和鼠标事件,该属性用于确定你按下的是哪一个键盘按键或鼠标按钮. which属性对DOM原生的event.keyCode和event.charCode进行了标准化. 适用的事件类型主要有键盘事件:keypress.keydown.keyup,以及鼠标事件:mouseup.mousedown. 该属性属于jQuery的Event对象(实例). 语法 jQuery 1.1.3 新			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/1Mvg15p.html" rel="bookmark">jQuery的deferred对象详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				jQuery的开发速度很快,几乎每半年一个大版本,每两个月一个小版本. 每个版本都会引入一些新功能.今天我想介绍的,就是从jQuery 1.5.0版本开始引入的一个新功能----deferred对象. 这个功能很重要,未来将成为jQuery的核心方法,它彻底改变了如何在jQuery中使用ajax.为了实现它,jQuery的全部ajax代码都被改写了.但是,它比较抽象,初学者很难掌握,网上的教程也不多.所以,我把自己的学习笔记整理出来了,希望对大家有用. 本文不是初级教程,针对的读者是那些已经具备			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze7nGAM.html" rel="bookmark">jQuery Validate 验证&comma;校验规则写在控件中的具体实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 本篇文章主要是对jQuery Validate 验证,校验规则写在控件中的具体实例进行了介绍,需要的朋友可以过来参考下,希望对大家有所帮助 将校验规则写到控件中    代码如下: &lt;script src=&quot;../js/jquery.js&quot; type=&quot;text/javascript&quot;&gt;&lt;/script&gt; &lt;script src=&quot;../js/jquery.validate.js&quot; type=&quot;text/j			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0bo7v3b.html" rel="bookmark" class="title">Windows 8系统添乱导致笔记本键盘失灵的解决方法</a>
					<div>
						目前Win 8尚处在预发布版的时候,各大软件厂商和在线服务提供商都在紧锣密鼓地开展开发和测试工作,为提供兼容 Windows 8 的程序做准备.在当时,我曾写过一则关于建行网银盾无法使用的问题和其解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7b29Oqz.html" rel="bookmark" class="title">如何通过鼠标指向图片来隐现文字</a>
					<div>
						鼠标 一个table或者&lt;DIV&gt;放置一张图片(有链接)和位于图片下方的一段文本,希望使得鼠标移到图片上时显示文本(图片也显示),鼠标移出时隐藏文本. &lt;!DOCTYPE html  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9V1Vp.html" rel="bookmark" class="title">除了微博营销 我们还需要做些什么 SEO？</a>
					<div>
						前几天,我曾经发过一篇文章&quot;从明星恋爱谈微博营销交互性你都知道吗&quot;,介绍微博营销那点事儿.今天,我将告诉大家,除了微博营销,我们还需要做些什么? 做过营销的朋友想必都知道,除了所谓 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bBBJJb.html" rel="bookmark" class="title">自己动手写Web容器之TomJetty（五） 包装请求参数</a>
					<div>
						前面我们实现了TomJetty响应无参请求静态页面的功能,但真实情况下,几乎所有请求都得携带参数.不能处理用户参数请求的Web服务器就好比温室里的花朵,始终上不了台面.所以本节我们将为TomJetty ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKZomM.html" rel="bookmark" class="title">Delphi与DirectX之DelphiX&lpar;31&rpar;：TDIB&period;Twist&lpar;&rpar;&semi;</a>
					<div>
						本例效果图: 代码文件: unit Unit1; interface uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Co ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo68LDz.html" rel="bookmark" class="title">php编写的闹钟程序</a>
					<div>
						&lt;?php //闹钟程序 error_reporting(7); ob_start(); if (!isset($i)) {     $msg= '现在时间是: '. date('h:i:s') ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1yjAz.html" rel="bookmark" class="title">Photoshop调出外景逆光人像质感肤色</a>
					<div>
						  本教程主要使用Photoshop调出外景逆光人像古铜色质感肤色,演员吴丹佳佳的这张外景照片在逆光中温婉而优雅,头发.礼服的颜色及背景的颜色在夕阳下显得和谐统一.喜欢的朋友让我们一起来学习吧. 案例 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKaWZM.html" rel="bookmark" class="title">华为路由器修改MTU值失败的原因</a>
					<div>
						MTU是MaximumTransmissionUnit的缩写,是网络上传送的最大数据包,大部分网络设备的MTU都是1500,MTU的单位是字节,如果本机的MTU比网关的MTU大,大的数据包就会被拆开来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7vNab.html" rel="bookmark" class="title">Windows 8 下怎么设置锁屏后的通知？</a>
					<div>
						  Win8 可以在屏幕锁定的状态下,指定显示某些应用程序的通知,未指定的其他程序通知只能在未锁定时显示. 首先确保系统下通知开启.打开Charm(超级按钮),选择&quot;设置&quot;,选择右 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWEZ7b.html" rel="bookmark" class="title">25款极简主义风格的摄影作品网页</a>
					<div>
						  NORDCIA Trigger Shoots Thomas Steibl Radny &amp; Erin Kinderfotografie Evi Hermans Mickey Shannon  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRw7O8p.html" rel="bookmark" class="title">win8系统下xlueops&period;exe进程能否关闭</a>
					<div>
						  细心的用户会在win8系统任务管理器中发现一个名为xlueops.exe的系统进程,该进程有时会占过多的系统CPU资源,不过不了解该进程的用户却不敢盲目的关闭,那么xlueops.exe是什么呢? ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNaJrM.html" rel="bookmark" class="title">Win8&sol;Win8&period;1下快速更换Office2013序列号</a>
					<div>
						  1.常规法 打开控制面板中的&quot;程序和功能项&quot;,进入&quot;卸载程序&quot;,找到Office2013套件安装项目,例如Microsoft Office Professi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z72GARp.html" rel="bookmark" class="title">Win7加密u盘的使用方法介绍</a>
					<div>
						  U盘在我们生活中有非常大的作用,u盘可以存储你的照片,文件等非常重要的内容.现在经过更新换代,一个4Gu盘也才几十块钱,同u盘的体积也在缩小,这就增加了丢失的几率.U盘丢了没什么,但是里面的文件丢 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGoWap.html" rel="bookmark" class="title">微店官网怎么开微店</a>
					<div>
						  百度搜索 微店网 找到如下图带有&quot;官网&quot;两个字的,点击进入; 微店官网打开后,点击右上角的&quot;登录&quot;,就会出现注册按钮,如下图,点击注册; 微店官网开微店必须 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXjAA5b.html" rel="bookmark" class="title">BIOS的定义与CMOS的区别，它们能不能互换？</a>
					<div>
						  BIOS,(Basic Input/output system)即基本输入/输出系统.它实际上是被固化到计算机中的一组程序,为计算机 提供最低级的.最直接的硬件控制.准确地说,BIOS是硬件与软件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9ErNXM.html" rel="bookmark" class="title">设计模式之动态代理&lpar;dynamic proxy&rpar;</a>
					<div>
						1 动态代理与静态代理 我们从上一篇设计模式之代理模式一文中已经知道,在代理模式中代理对象和被代理对象一般实现相同的接口,调用者与代理对象进行交互.代理的存在对于调用者来说是透明的,调用者看到的只是接 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVNnPmz.html" rel="bookmark" class="title">解决oracle 11g库shutdown导致10g库的crsd进程重启办法</a>
					<div>
						客户有个环境是10g的RAC,由于一次偶尔的需求,需要将一个11g的数据库临时在上面启动,当我们mount了11g的软件卷和datafile 卷之后,11g的数据库能正常启动,但是当11g的数据库sh ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b32XxJz.html" rel="bookmark" class="title">积累的VC编程小技巧之标题栏和菜单</a>
					<div>
						1.窗口最大最小化按纽的控制 ①怎样在程序开始的时候让它最大化? ②vc++做出来的exe文件在窗体的右上方是没有最大化和最小化按钮的,怎样实现这一功能? ③如何在显示窗口时,使最大化按钮变灰?    ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRqo5Gb.html" rel="bookmark" class="title">数据库数据恢复-读取iphone手机图片数据库，其中的图片位置信息是一段以bplist00开头的字符串</a>
					<div>
						问题描述 读取iphone手机图片数据库,其中的图片位置信息是一段以bplist00开头的字符串 图片位置信息是一串以bplist00开头的字符串,其中包含了图片拍摄的中文位置信息,如何将里边的位置信 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4NOZ1M.html" rel="bookmark" class="title">Qt 子窗口父窗口切换，窗口间传值</a>
					<div>
						 本人代码 代码下载:http://download.csdn.net/detail/u013378306/9621322 效果:实现 父窗口 打开子窗口,关闭子窗口,子窗口向父窗口传值 win_wi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV0QynM.html" rel="bookmark" class="title">c语言-自己用c写的录音代码播放没声音，可以保证播放部分没有问题，等大神</a>
					<div>
						问题描述 自己用c写的录音代码播放没声音,可以保证播放部分没有问题,等大神 #include #include #include #include #include typedef struct WA ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXqVjyz.html" rel="bookmark" class="title">编程-BootStrap可视化工具是如何实现的&quest;</a>
					<div>
						问题描述 BootStrap可视化工具是如何实现的? 我也想写一套自己的可视化工具,但是没有什么思路 解决方案 无结果答案 无结果答案 无结果答案 解决方案二: Layout It 是一个在线工具,它 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3rmxJz.html" rel="bookmark" class="title">【人生苦短，我用Python】Python免费精品课连载&lpar;1&rpar;&mdash;&mdash;Python入门</a>
					<div>
						课程学习:零基础入门学习Python - 阿里云大学 上图中T恤上印着&quot;人生苦短,我用Python&quot;的大牛就是Python的创始人Guido van Rossum.其实这句话来自B ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKAOjb.html" rel="bookmark" class="title">小米手机迎来CM10&period;1 ROM 体验Android 4&period;2</a>
					<div>
						&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp;   由于Android 4.2.2的部分功能已经在MIUI ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mgw2AmM.html" rel="bookmark" class="title">后市预期乐观开发商上海拿地势头不减</a>
					<div>
						唐文祺 &quot;签订土地出让合同之日起10个自然日内付清出让金&quot;,这一前所未有的条款设定,在日前上海奉贤区几幅土地的出让文件中被屡屡提及,但堪称&quot;苛刻&quot;的门槛并未阻止 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGrZq2p.html" rel="bookmark" class="title">AngularJS入门教程之过滤器详解&lowbar;AngularJS</a>
					<div>
						在这一步你将学习到如何创建自己的显示过滤器. 请重置工作目录: git checkout -f step-9 现在转到一个手机详细信息页面.在上一步,手机详细页面显示&quot;true&quot;或 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV7YOQb.html" rel="bookmark" class="title">配置高可用 mongodb 集群教程</a>
					<div>
						在大数据的时代,传统的关系型数据库要能更高的服务必须要解决高并发读写.海量数据高效存储.高可扩展性和高可用性这些难题.不过就是因为这些问题Nosql诞生了. NOSQL有这些优势: 大数据量,可以通过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8edKb.html" rel="bookmark" class="title">win7中vc&plus;&plus;如何获取硬盘序列号</a>
					<div>
						问题描述 win7中vc++如何获取硬盘序列号 我想获取win7下计算机硬盘的序列号,用来做软件加密,求各位大神帮帮忙啊!!!!!!! 解决方案 http://blog.163.com/jinfd@1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYNlOxp.html" rel="bookmark" class="title">《树莓派实战秘籍》&mdash;&mdash;第 1 章　配置技巧</a>
					<div>
						第 1 章 配置技巧 树莓派实战秘籍人们会说起点通常就是开始的好地方什么的,但是这是一本黑客的书,你很可能会跳过无关内容而直奔感兴趣的话题.要不就是这本书前面一定是用古代英语写的,因为你在不停的翻页, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOWmvqz.html" rel="bookmark" class="title">Spark架构在大数据环境的核心位置找到用武之地</a>
					<div>
						Webtrends公司的IT团队在Apache Spark这款处理引擎还是一项学术研究项目的时候就已经开始使用它并沿用至今.但当Webtrends在2014年年中部署了一套基于Hadoop的大数据环境 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.048 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
